<template>
	<div class="os-locker">
		<h1 class="intro__title"><mark>Проверяем</mark><br>твою оплату...</h1>
		<p class="intro__text">Нам нужно несколько секунд, чтобы свериться с платёжной системой. Мы проверим,
			поступил ли твой платёж. Если всё ок, ниже ты увидишь дальнейшие инструкции.</p>

		<div v-if="success_statuses.indexOf(status) == -1" :class="`os-locker__status os-locker__status--${status}`">{{ texts[status] || '' }}</div>

		<div class="os-locker--captured" v-else-if="status == 'payment_captured' || status == 'payment_auth'">
			<slot></slot>
		</div>
	</div>
</template>

<script>
export default {
	data() {
		return {
			status: 'loading',
			interval: null,
			order_id: this.$route.query.order_id || false,

			final_statuses: ['cancelled', 'payment_captured', 'payment_auth'],
			success_statuses: ['payment_captured', 'payment_auth'],

			texts: {
				loading: 'Загружаем информацию о заказе...',
				not_payed: 'Ожидаем поступления платежа...',
				cancelled: "Ваш заказ был отменён, оплата не прошла. Повторите попытку снова."
			}
		}
	},

	mounted(){
		this.interval = setInterval(() => {
			this.check();
			if (this.final_statuses.indexOf(this.status) != -1) {
				clearInterval(this.interval);
			}
		}, 1000);
	},
	methods: {
		check() {
			this.$axios.get(`https://s.va-promotion.ru/api/order/${this.order_id}`).then((r) => {
				this.status = r.data.status;
			});
		}
	}
}
</script>

<style lang="scss">
.os-locker {
	&__status {
		padding: 30px;
		border-radius: 4px;
		background-color: rgba($primary, 0.05);
		border: 1px dashed $primary;
		margin: 20px 0px 0px;
		&--cancelled {
			border-color: rgb(202, 15, 15);
			background-color: rgba(202, 15, 15, 0.05);
		}
	}
}
</style>
